Codeforces C. Arpa’s overnight party and Mehrdad’s silent entering

【题意】

给出n对情侣的位置,围成环,现在需要分配食物,使得每个人都是1或2,满足任意

一对情侣间的食物不同,连着三个人的食物不能全相同。

请给出任意一种分配方案,若不存在输出-1。

【分析】

每个人相当于节点,每个节点有两种选择,然后很自然的想到了01染色,第一个约

束条件是情侣之间选择不同,即情侣之间连一条边,第二个条件是连着的三个人食

物不能全相同,也就是任意的三个节点至少有一对相邻节点不相同,所以我们把这

个圆圈的点依次连边,即(1, 2)、(3, 4),(4,5)….连边。

但是这样连边与原题中的约束条件等价吗?我们可以保证,这样连边以后跑出来的

方案一定是满足题意的,但是会不会存在出现无解的情况呢?显然,我们这样连边

每个节点的度数都为2,即整个图是由若干个环组成的,并且不存在奇数点环(同一

个环内包含若干对情侣),这样01染色肯定是存在方案的

#include<cstdio>
#include<iostream>
#include<cstring>
#include<vector>
using namespace std;

const int N = 100000 + 500;
int x[N * 2], y[N * 2];
vector<int> s[N * 2];
int f[N * 2];

void dfs(int x, int col)
{
    for(int i = 0; i < s[x].size(); i++){
        int y = s[x][i];
        if (!f[y]){
            f[y] = 3 - col;
            dfs(y, 3 - col);
        }
    }
}
int main()
{
    int n ;
    scanf("%d", &n);
    for(int i = 1; i <= n; i++){
        scanf("%d%d", &x[i], &y[i]);
        s[x[i]].push_back(y[i]);
        s[y[i]].push_back(x[i]);
    }
    for(int i = 1; i <= n; i++){
        s[i << 1].push_back((i << 1) - 1);
        s[(i << 1) - 1].push_back(i << 1);
    }
    for(int i = 1; i <= 2 * n; i++)
        if (!f[i])
    {
        f[i] = 1;
        dfs(i, 1);
    }
    for(int i = 1; i <= n; i++){
        printf("%d %d\n", f[x[i]], f[y[i]]);
    }
    return 0;
}
The problem statement can be found at Codeforces website. Approach: Let's start by looking at some examples: - 1, 2, 3, 4, 5 → No moves needed. - 2, 1, 3, 5, 4 → One move needed: swap index 1 and 2. - 5, 4, 3, 2, 1 → Two moves needed: swap index 1 and 5, then swap index 2 and 4. We can observe that in order to minimize the number of moves, we need to sort the array in non-descending order and keep track of the number of swaps we make. We can use bubble sort to sort the array and count the number of swaps. Let's see how bubble sort works: - Start from the first element, compare it with the second element, and swap them if the second element is smaller. - Move to the second element, compare it with the third element, and swap them if the third element is smaller. - Continue this process until the second-to-last element. At this point, the largest element is in the last position. - Repeat the above process for the remaining elements, but exclude the last position. In each iteration of the above process, we can count the number of swaps made. Therefore, the total number of swaps needed to sort the array can be obtained by summing up the number of swaps made in each iteration. Implementation: We can implement the above approach using a simple bubble sort algorithm. Here's the code: - First, we read the input array and store it in a vector. - We define a variable to keep track of the total number of swaps made and set it to 0. - We run a loop from the first element to the second-to-last element. - In each iteration of the above loop, we run another loop from the first element to the second-to-last element minus the current iteration index. - In each iteration of the inner loop, we compare the current element with the next element and swap them if the next element is smaller. - If a swap is made, we increment the total number of swaps made. - Finally, we output the total number of swaps made. Time Complexity: The time complexity of bubble sort is O(n^2). Therefore, the overall time complexity of the solution is O(n^2). Space Complexity: We are using a vector to store the input array. Therefore, the space complexity of the solution is O(n). Let's see the implementation of the solution.
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值